[<prev] [next>] [<thread-prev] [thread-next>] [day] [month] [year] [list]
Message-ID: <ab460ce5-c635-4fe5-99e6-04d889021b2c@redhat.com>
Date: Tue, 24 Sep 2024 18:41:40 +0200
From: Veronika Molnarova <vmolnaro@...hat.com>
To: Ian Rogers <irogers@...gle.com>, Peter Zijlstra <peterz@...radead.org>,
Ingo Molnar <mingo@...hat.com>, Arnaldo Carvalho de Melo <acme@...nel.org>,
Mark Rutland <mark.rutland@....com>,
Alexander Shishkin <alexander.shishkin@...ux.intel.com>,
Jiri Olsa <jolsa@...nel.org>, Namhyung Kim <namhyung@...nel.org>,
Adrian Hunter <adrian.hunter@...el.com>,
Athira Rajeev <atrajeev@...ux.vnet.ibm.com>,
linux-perf-users@...r.kernel.org, linux-kernel@...r.kernel.org
Subject: Re: [PATCH v2] perf test: Be more tolerant of metricgroup failures
On 9/23/24 20:51, Ian Rogers wrote:
> On Thu, May 2, 2024 at 3:31 PM Ian Rogers <irogers@...gle.com> wrote:
>>
>> Previously "set -e" meant any non-zero exit code from perf stat would
>> cause a test failure. As a non-zero exit happens when there aren't
>> sufficient permissions, check for this case and make the exit code
>> 2/skip for it.
>>
>> Acked-by: Namhyung Kim <namhyung@...nel.org>
>> Signed-off-by: Ian Rogers <irogers@...gle.com>
>> ---
>> v2. Add skip if event mode isn't valid in per-thread mode. Suggested
>> by Veronika Molnarova <vmolnaro@...hat.com>.
>
> Ping.
>
> Thanks,
> Ian
>
>> ---
>> .../perf/tests/shell/stat_all_metricgroups.sh | 36 +++++++++++++++----
>> 1 file changed, 30 insertions(+), 6 deletions(-)
>>
>> diff --git a/tools/perf/tests/shell/stat_all_metricgroups.sh b/tools/perf/tests/shell/stat_all_metricgroups.sh
>> index 55ef9c9ded2d..c6d61a4ac3e7 100755
>> --- a/tools/perf/tests/shell/stat_all_metricgroups.sh
>> +++ b/tools/perf/tests/shell/stat_all_metricgroups.sh
>> @@ -1,9 +1,7 @@
>> -#!/bin/sh
>> +#!/bin/bash
>> # perf all metricgroups test
>> # SPDX-License-Identifier: GPL-2.0
>>
>> -set -e
>> -
>> ParanoidAndNotRoot()
>> {
>> [ "$(id -u)" != 0 ] && [ "$(cat /proc/sys/kernel/perf_event_paranoid)" -gt $1 ]
>> @@ -14,11 +12,37 @@ if ParanoidAndNotRoot 0
>> then
>> system_wide_flag=""
>> fi
>> -
>> +err=0
>> for m in $(perf list --raw-dump metricgroups)
>> do
>> echo "Testing $m"
>> - perf stat -M "$m" $system_wide_flag sleep 0.01
>> + result=$(perf stat -M "$m" $system_wide_flag sleep 0.01 2>&1)
>> + result_err=$?
>> + if [[ $result_err -gt 0 ]]
>> + then
>> + if [[ "$result" =~ \
>> + "Access to performance monitoring and observability operations is limited" ]]
>> + then
>> + echo "Permission failure"
>> + echo $result
>> + if [[ $err -eq 0 ]]
>> + then
>> + err=2 # Skip
>> + fi
>> + elif [[ "$result" =~ "in per-thread mode, enable system wide" ]]
>> + then
>> + echo "Permissions - need system wide mode"
>> + echo $result
>> + if [[ $err -eq 0 ]]
>> + then
>> + err=2 # Skip
>> + fi
>> + else
>> + echo "Metric group $m failed"
>> + echo $result
>> + err=1 # Fail
>> + fi
>> + fi
>> done
>>
>> -exit 0
>> +exit $err
>> --
>> 2.45.0.rc1.225.g2a3ae87e7f-goog
>>
>
Acked-by: Veronika Molnarova <vmolnaro@...hat.com>
Thanks,
Veronika
Powered by blists - more mailing lists